#!/bin/bash
# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
# ex: ts=8 sw=4 sts=4 et filetype=sh
#
# This file is part of systemd.
#
# Copyright 2013 Harald Hoyer
#
# systemd is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or
# (at your option) any later version.
#
# systemd is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with systemd; If not, see <http://www.gnu.org/licenses/>.

export LC_COLLATE=C

COMMAND="$1"
KERNEL_VERSION="$2"
KERNEL_IMAGE="$3"

if [[ -x /sbin/new-kernel-pkg ]]; then
    case "$COMMAND" in
        add)
            /sbin/new-kernel-pkg --package kernel --mkinitrd --dracut --depmod --install "$KERNEL_VERSION" || exit $?
            /sbin/new-kernel-pkg --package kernel --rpmposttrans "$KERNEL_VERSION" || exit $?
            ;;
        remove)
            /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove "$KERNEL_VERSION" || exit $?
            ;;
        *)
            ;;
    esac

    # exit, if we can't find a boot loader spec conforming setup
    if ! [[ -d /boot/loader/entries || -L /boot/loader/entries ]]; then
        exit 0
    fi
fi

[[ -f /etc/os-release ]] && . /etc/os-release
if ! [[ $ID ]]; then
    echo "Can't determine the name of your distribution. Please create /etc/os-release." >&2
    echo "See man:os-release(5)" >&2
    exit 1
fi

[[ -f /etc/machine-id ]] && read MACHINE_ID < /etc/machine-id
if ! [[ $MACHINE_ID ]]; then
    echo "Can't determine your machine id. Please create /etc/machine-id!" >&2
    echo "See man:machine-id(5)" >&2
    exit 1
fi

if [[ -f /etc/kernel/cmdline ]]; then
    readarray -t BOOT_OPTIONS < /etc/kernel/cmdline
fi

if ! [[ "${BOOT_OPTIONS[@]}" ]]; then
    readarray -t BOOT_OPTIONS < /proc/cmdline
fi

if ! [[ $BOOT_OPTIONS ]]; then
    echo "Can't determine the kernel command line parameters." >&2
    echo "Please specify the kernel command line in /etc/kernel/cmdline!" >&2
    exit 1
fi

usage()
{
    {
        echo "Usage:"
        echo "        $0 add <kernel-version> <kernel-image>"
        echo "        $0 remove <kernel-version> <kernel-image>"
    } >&2
}

if ! ( [[ $COMMAND ]] && [[ $KERNEL_VERSION ]] ); then
    usage
    exit 1
fi

BOOT_DIR="/${MACHINE_ID}/${KERNEL_VERSION}"
BOOT_DIR_ABS="/boot${BOOT_DIR}"
LOADER_ENTRY="/boot/loader/entries/${MACHINE_ID}-${KERNEL_VERSION}.conf"
ret=0

dropindirs_sort()
{
    suffix=$1; shift
    readarray -t files< <(
        for d in "$@"; do
            for i in "${d}/"*${suffix}; do
                [[ -e $i ]] && echo ${i##*/}
            done
        done | sort -Vu
    )

    for f in "${files[@]}"; do
        for d in "$@"; do
            if [[ -e "$d/$f" ]]; then
                echo "$d/$f"
                continue 2
            fi
        done
    done
}

readarray -t PLUGINS < <(
    dropindirs_sort ".install" \
        "/etc/kernel/install.d" \
        "/usr/lib/kernel/install.d"
)

case "$COMMAND" in
    add)
        if [[ -z $KERNEL_IMAGE ]]; then
            usage
            exit 1
        fi
        mkdir -p "$BOOT_DIR_ABS" || exit 1

        for f in "${PLUGINS[@]}"; do
            [[ -x $f ]] && "$f" add "$KERNEL_VERSION" "$BOOT_DIR_ABS"
            ((ret+=$?))
        done

        if ! cp --preserve "$KERNEL_IMAGE" "$BOOT_DIR_ABS"/linux; then
            echo "Can't copy '$KERNEL_IMAGE to '$BOOT_DIR_ABS/linux'!" >&2
        fi

        [[ -d /boot/loader/entries ]] || mkdir -p /boot/loader/entries

        {
            echo "title      $PRETTY_NAME"
            echo "version    $KERNEL_VERSION"
            echo "machine-id $MACHINE_ID"
            echo "options    ${BOOT_OPTIONS[@]}"
            echo "linux      $BOOT_DIR/linux"
            [[ -f "${BOOT_DIR_ABS}"/initrd ]] && \
                echo "initrd     $BOOT_DIR/initrd"
            :
        } > $LOADER_ENTRY

        ((ret+=$?))

        if ! [[ -f $LOADER_ENTRY ]]; then
            echo "Could not create '$LOADER_ENTRY'!" >&2
        fi
        ;;

    remove)
        for f in "${PLUGINS[@]}"; do
            [[ -x $f ]] && "$f" remove "$KERNEL_VERSION" "$BOOT_DIR_ABS"
            ((ret+=$?))
        done

        rm -fr "$BOOT_DIR_ABS"
        rm -f "$LOADER_ENTRY"
        ;;

    *)
        usage
        ret=1;;
esac

((ret+=$?))

exit $ret
